
;______Reloj en ASM_____
;SETA pruebas xsetaseta@gmail.com
.include "m88def.inc"

.dseg
nu1:	.byte 1		;representación numero de 9 cifras
nu2:	.byte 1
nu3:	.byte 1
nu4:	.byte 1
nu5:	.byte 1
nu6:	.byte 1
nu7:	.byte 1
nu8:	.byte 1
nu9:	.byte 1
nu10:	.byte 1

num0:	.byte 1		;numero de 4bytes para convertir
num1:	.byte 1
num2:	.byte 1
num3:	.byte 1

.cseg
.def temp=r16		;utilizado en incrementos
.def temp2=r17
.def tiempo=r18
.def tiempo1=r19
.def tiempo2=r20
.def menu=r21
.def sele=r22
.def incremento=r23
.def argu=r24		;argumento de 1byte
.def argu2=r25
.def seg=r0
.def min=r1
.def hor=r2
.def dia=r3		;empieza en 0
.def mes=r4		;valores de 0-11
.def ano=r5		;valores de 0-99

.org 0x0000
		rjmp reset
.org 0x0009
		rjmp interup0
interup0:	
		ldi incremento,1
		reti		
reset:
		ldi R25,LOW(ramend) ;Coloca la pila al final de la memoria RAM
		out SPL,R25
		ldi R25,HIGH(ramend)
		out SPH,R25

        ser temp		;temp=255
        out DDRB,temp ;Puerto D como salida
		ser temp		;temp=255
        out DDRC,temp ;Puerto C como salida
		ldi temp,0x20; 
        out DDRD,temp ;//puerto D 0000-1111 0=entrada 1=salida
		rcall LCD_INI		
		rcall LCD_CLS
		rcall LCD_HOME

		ldi temp,0x05		; // divide entre 128
		sts TCCR2B,temp
		ldi temp,32			;//Utiliza cristal
		sts ASSR,temp
		ldi temp,1			;Mascara interrupcion2
		sts TIMSK2,temp

		sei				;activa interupciones
		ldi argu,10		;espera a que se estabilice la interupción
        rcall Delay1mS	;Al principio se me activa una interupción

		rcall clearhora
		rcall clearfecha
;__________________________________________
inicio:  
		in  menu,PIND 
menu1:
		mov temp2,menu
		andi temp2,64	;Detecta incremento
		breq menu2
		
		
				
ino0:	cpi sele,0
		brne ino1		
		rjmp irmenu2x

ino1:	ldi argu,200	;espera 1/2 segundo
		rcall Delay10mS	

		cpi sele,1
		brne ino2
		rcall increho
		rjmp irmenu2x		
ino2:	cpi sele,2
		brne ino3
		clr seg
		;cli
		rcall incremi
		rjmp irmenu2x
ino3:	cpi sele,3
		brne ino4
		rcall increse
		rjmp irmenu2x
ino4:	cpi sele,4
		brne ino5
		rcall incredia
		rjmp irmenu2x				
ino5:	cpi sele,5
		brne ino6
		rcall incremes
		rjmp irmenu2x		
ino6:	cpi sele,6
		brne irmenu2x
		rcall increano

irmenu2x:

		rcall printhora
		rcall printfecha
		ldi argu,150
		rcall Delay1mS

menu2:	
		mov temp2,menu	;Selección
		andi temp2,128
		breq xmenu
		ldi argu,15
		rcall LCD_AT
		

		
		inc sele
		cpi sele,7
		brne no0
		clr sele

no0:		ldi argu,200	;espera 1/2 segundo
		rcall Delay10mS

		cpi sele,0
		brne no1
		ldi argu,32		;" "
		rjmp rmenu2x
no1:	cpi sele,1
		brne no2
		ldi argu,72		;"H"
		rjmp rmenu2x		
no2:	cpi sele,2
		brne no3
		ldi argu,77		;"M"
		rjmp rmenu2x
no3:	cpi sele,3
		brne no4
		ldi argu,83		;"S"
		rjmp rmenu2x
no4:	cpi sele,4
		brne no5
		ldi argu,100	;"d"
		rjmp rmenu2x				
no5:	cpi sele,5
		brne no6
		ldi argu,109	;"m"
		rjmp rmenu2x		
no6:	cpi sele,6
		brne no7
		ldi argu,97		;"a"
		rjmp rmenu2x	
no7:	
		clr sele
rmenu2x:
		rcall SENDCHAR
		ldi argu,150
		rcall Delay1mS		
xmenu:	
		cpi incremento,1
		brne nocambio
		rcall increse
		rcall printhora
		rcall printfecha
		clr incremento
		cbi PORTD,5
		sbrc seg,0
		sbi PORTD,5
		ldi argu,17
		rcall LCD_AT
nocambio:		
		
        rjmp inicio

;________________________________________
increse:
		inc seg
		ldi temp,60
		cp seg,temp
		brne xincrese
		clr seg
		rcall incremi
xincrese:
		ret

incremi:
		inc min
		ldi temp,60
		cp min,temp
		brne xincremi
		clr min
		cpi sele,0
		brne xincremi
		rcall increho
xincremi:
		ret

increho:
		inc hor
		ldi temp,24
		cp hor,temp
		brne xincreho
		clr hor
		cpi sele,0
		brne xincreho
		rcall incredia
xincreho:
		ret

incredia:
		inc dia
		ldi temp,28		;detecta febrero 28 dias
		cp dia,temp		;no detecta bisiestos
		brne incre30
		ldi temp,1
		cp mes,temp
		breq cincredia		
incre30:
		ldi temp,30		;Detectar 30 dias abril-junio-sep-novi
		cp dia,temp
		brne incre31
		ldi temp,3
		cp mes,temp
		breq cincredia
		ldi temp,5
		cp mes,temp
		breq cincredia
		ldi temp,8
		cp mes,temp
		breq cincredia
		ldi temp,10
		cp mes,temp
		breq cincredia
incre31:
		ldi temp,31		
		cp dia,temp
		brne xincredia		
cincredia:		
		clr dia
		cpi sele,0
		brne xincredia
		rcall incremes
xincredia:
		ret

incremes:
		inc mes
		ldi temp,12
		cp mes,temp
		brne xincremes
		clr mes
		cpi sele,0
		brne xincremes
		rcall increano
xincremes:
		ret

increano:
		inc ano
		ret

clearhora:
		clr seg
		clr min
		clr hor
		ret

clearfecha:
		clr dia
		clr mes
		clr ano
		ret

printhora:
		push temp
		clr temp
		sts num3,temp
		sts num2,temp
		sts num1,temp
		sts num0,hor
		rcall BINTODEC
		ldi argu,0
		ldi argu2,2
		rcall PrintAtNum
		ldi argu,58
		rcall SENDCHAR
		sts num0,min
		rcall BINTODEC
		ldi argu,3
		ldi argu2,2
		rcall PrintAtNum
		ldi argu,58
		rcall SENDCHAR
		sts num0,seg
		rcall BINTODEC
		ldi argu,6
		ldi argu2,2
		rcall PrintAtNum
		pop temp
		ret

printfecha:
		push temp
		clr temp
		sts num3,temp
		sts num2,temp
		sts num1,temp
		mov temp,dia
		inc temp
		sts num0,temp
		rcall BINTODEC
		ldi argu,64
		ldi argu2,2
		rcall PrintAtNum
		ldi argu,45
		rcall SENDCHAR
		ldi ZH,HIGH(2*ener)
		ldi ZL,LOW(2*ener)
		mov temp,mes
rmes:
		cpi temp,0	
		breq xmes
		dec temp
		adiw zl,6	;Caracteres de los meses
		rjmp rmes
xmes:
		ldi argu,67
		rcall PrintAtStr
		ldi argu,45
		rcall SENDCHAR
		ldi argu,50		;2
		rcall SENDCHAR
		ldi argu,48		;0
		rcall SENDCHAR
		sts num0,ano	;Solo 100 años
		rcall BINTODEC
		ldi argu,75
		ldi argu2,2
		rcall PrintAtNum
		
		pop temp				
		ret

texto1:
.DB "   JUAN GALAZ  ",0x00
texto2:
.DB "xsetaseta@GMAIL",0x00
ener:
.db "ENERO",0x00
febr:
.db "FEBRE",0x00
marz:
.db "MARZO",0x00
abri:
.db "ABRIL",0x00
mayo:
.db "MAYO ",0x00
juni:
.db "JUNIO",0x00
juli:
.db "JULIO",0x00
agos:
.db "AGOST",0x00
sept:
.db "SEPTI",0x00
octu:
.db "OCTUB",0x00
novi:
.db "NOVIE",0x00
dici:
.db "DICIE",0x00



;______________________________________
BINTODEC:			;Convierte num0-3 a nu1-9 decimal (num0-3 se destruyen)
		push r16
		push r17
		push r18
		push r19
		push r0
		push r1
		push r2
		push r3

		ldi r16,0x00	;1.000.000.000
		ldi r17,0xca
		ldi r18,0x9a
		ldi r19,0x3b
		rcall divix
		sts nu10,argu

		ldi r16,0x00	;100.000.000
		ldi r17,0xe1
		ldi r18,0xf5
		ldi r19,0x05
		rcall divix
		sts nu9,argu

		ldi r16,0x80	;10.000.000
		ldi r17,0x96
		ldi r18,0x98
		clr r19
		rcall divix
		sts nu8,argu

		ldi r16,0x40	;1.000.000
		ldi r17,0x42
		ldi r18,0x0f
		clr r19
		rcall divix
		sts nu7,argu

		ldi r16,0xa0	;100.000
		ldi r17,0x86
		ldi r18,0x01
		clr r19
		rcall divix
		sts nu6,argu

		ldi r16,0x10	;1.0000
		ldi r17,0x27
		clr r18
		clr r19
		rcall divix
		sts nu5,argu
saltoborra:
		ldi r16,0xe8	;1000
		ldi r17,0x03
		clr r18
		clr r19
		rcall divix
		sts nu4,argu

		ldi r16,0x64	;100	
		clr r17
		clr r18
		clr r19
		rcall divix
		sts nu3,argu

		ldi r16,0x0a	;10
		clr r17
		clr r18
		clr r19
		rcall divix
		sts nu2,argu

		lds r0,num0
		sts nu1,r0		;1

		pop r3
		pop r2
		pop r1
		pop r0
		pop r19
		pop r18
		pop r17
		pop r16
		ret

divix:	;Divide numero() entre r16-r19
		clr argu
		lds r0,num0
		lds r1,num1
		lds r2,num2
		lds r3,num3
divixvolver:
		sts num0,r0
		sts num1,r1
		sts num2,r2
		sts num3,r3
		sub r0,r16
		sbc r1,r17
		sbc r2,r18
		sbc r3,r19
		brcs exitdivix
		inc argu
		rjmp divixvolver			
exitdivix:
		ret


PrintAtNum: ;AT=arg  Numero cifras=argu2
		rcall LCD_AT
		ldi	temp,48
		cpi argu2,2
		breq cifras2
		cpi argu2,3
		breq cifras3
		cpi argu2,6
		breq cifras6
		lds argu,nu10
		add argu,temp
		rcall SENDCHAR
		lds argu,nu9
		add argu,temp
		rcall SENDCHAR
		lds argu,nu8
		add argu,temp
		rcall SENDCHAR
		lds argu,nu7
		add argu,temp
		rcall SENDCHAR
cifras6:
		lds argu,nu6
		add argu,temp
		rcall SENDCHAR
		lds argu,nu5
		add argu,temp
		rcall SENDCHAR
		lds argu,nu4
		add argu,temp
		rcall SENDCHAR
cifras3:
		lds argu,nu3
		add argu,temp
		rcall SENDCHAR
cifras2:
		lds argu,nu2
		add argu,temp
		rcall SENDCHAR
		lds argu,nu1
		add argu,temp
		rcall SENDCHAR
		ret

PrintAtStr:	;AT=argu , STR=z
		rcall LCD_AT
Print1:
		lpm argu,z+
		and argu,argu
		breq Print2		;finaliza si es cero
		rcall SENDCHAR
		rjmp Print1
Print2:
		ret
LCD_CLS:
		ldi argu,1
		rcall SENDI
		ret
LCD_HOME:
		ldi argu,2
		rcall SENDI
		ret
LCD_AT:
		ori argu,128
		rcall SENDI
		ret
LCD_INI:
		ldi argu,10	;100
		rcall Delay1mS
		ldi argu,0x03
		rcall Pon4bits

		cbi PORTB,5  
		rcall ENABLE	
		sbi PORTB,5		
		ldi argu,3	;30
		rcall Delay1mS	
		ldi argu,0x03
		rcall Pon4bits	
		cbi PORTB,5		
		rcall ENABLE	
		sbi PORTB,5		
		ldi argu,3	;30
		rcall Delay1mS	
		ldi argu,0x03
		rcall Pon4bits	
		cbi PORTB,5  	
		rcall ENABLE	
		sbi PORTB,5		
		ldi argu,3	;30
		rcall Delay1mS	

		ldi argu,0x02
		rcall Pon4bits	
		cbi PORTB,5  	
		rcall ENABLE	
		sbi PORTB,5		
		
		ldi argu,0x2c	
		rcall SENDI
		ldi argu,0x0f	
		rcall SENDI
		ldi argu,0x04	
		rcall SENDI	
		ldi argu,0x06	  ;cambio para lcd
		rcall SENDI
		ret

SENDCHAR:
		push argu
		push temp
		push temp2
		mov temp2,argu
		mov temp,argu
		ror temp
		ror temp
		ror temp
		ror temp
		mov argu,temp
		rcall Pon4bits
		rcall ENABLE
		mov argu,temp2
		rcall Pon4bits
		rcall ENABLE
		pop temp2
		pop temp
		pop argu		
		ret

Pon4bits:
		push argu
		push temp2
		in temp2,PORTB;
		andi temp2,0xf0
		andi argu,0x0f
		or argu,temp2
		out PORTB,argu
		pop temp2
		pop argu
		ret

SENDI:	
		push argu
		cbi PORTB,5	
		rcall SENDCHAR	
		ldi argu,1
		rcall Delay100uS	;rcall Delay1mS
		sbi PORTB,5		;
		pop argu
		ret

ENABLE:
		push argu
		sbi PORTB,4
		ldi argu,1
		rcall Delay100uS	;rcall Delay1mS
		cbi PORTB,4
		pop argu
		ret

Delay10mS:		
		mov tiempo,argu
zDela1:	ldi tiempo1,56  ;1Mhz->10,09mS->56  4mhz->9.99mS->222   20mhz->10.03mS->227
zDela2:	ldi tiempo2,44	;4mhz->9.99mS->44   20mhz->10.03mS->220
zDela3:	nop
		dec tiempo2
		brne zDela3
		nop
		dec tiempo1
		brne zDela2
		dec tiempo
		brne zDela1
		ret

Delay1mS:		
		mov tiempo,argu
Dela1:	ldi tiempo1,28	;1Mhz->1018uS->28  4mhz-20mhz->111
Dela2:	ldi tiempo2,8	;4 mhz->999uS->8   20mhz->999.5uS->44
Dela3:	nop
		dec tiempo2
		brne Dela3
		nop
		dec tiempo1
		brne Dela2
		dec tiempo
		brne Dela1
		ret

Delay100uS:		
		mov tiempo,argu
yDela1:	ldi tiempo1,11
yDela2:	ldi tiempo2,1	;1Mhz-98uS->1  4mhz->101.5uS->8  20mhz->99.5uS->44
yDela3:	nop
		dec tiempo2
		brne yDela3
		nop
		dec tiempo1
		brne yDela2
		dec tiempo
		brne yDela1
		ret
